﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Reporting.WebForms;
using VeteransAffairs.Registries.Business;
using VeteransAffairs.Registries.Business.Utilities;
using VeteransAffairs.Registries.BusinessManager;
using VeteransAffairs.Registries.BusinessManager.Utilities;
using VeteransAffairs.Registries.BusinessManager.TBI;
using VHAReportViewer;

public partial class PatientHealthFactors : BasePage
{
    #region Variable Declarations

    private ReportViewerHandler _reportViewerHandler;
    private UserAccountManager _currentUser;
    //TBIExceptionHandler _tbiexception = new TBIExceptionHandler();

    #endregion

    #region Public Ovverrides

    public override string TopMenuName()
    {
        return "My Tasks";
    }
    public override string MenuItemName()
    {
        return "TBI NOTICES";
    }
    public override string AppObjectCode()
    {
        return "TBI NOTICES";
    }

    #endregion

    #region Protected Methods

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            HiddenFieldBreadCrumbBaseText.Value = LabelBreadCrumb.Text;

            TBI_REFERRAL referral;
            TBIReferralManager referralManager = new TBIReferralManager();
            int _referralId;
            string _facilityId;
            string _ssn;
            if (int.TryParse(Request.QueryString["id"], out _referralId))
            {
                referral = referralManager.SelectByID(_referralId);
                _ssn = referral.PATIENT.SSN;

                //_facilityId = referral.PATIENT.STD_INSTITUTION_ID.ToString();
                _facilityId = referral.STD_INSTITUTION.STATIONNUMBER.ToString();   
                HiddenFieldReferralID.Value = _referralId.ToString();

                LabelBreadCrumb.Text = "My Tasks > Referrals > Health Factors" + " > View Report For Patient: " + HiddenFieldReferralID.Value;  
            }   
            else
            {
                _ssn = "";
                _facilityId = "";
            }
            

            ViewState["ReportViewerHandler"] = _reportViewerHandler = new ReportViewerHandler();

            string userId = System.Security.Principal.WindowsIdentity.GetCurrent().Name;
            UserAccountManager _currentUser1 = (UserAccountManager)HttpContext.Current.User;

            try
            {
                ReportViewer1.Reset();
                ReportViewer1.ServerReport.ReportPath = "VeteransScreeningQuestions";
                ReportViewer1.ServerReport.ReportServerUrl = new Uri(Helpers.GetConfigEntry("ReportingServer"));

                if (ReportViewer1.ServerReport.ReportPath.IndexOf(Helpers.GetConfigEntry("BaseReportPath"), 0) == -1)
                {
                    ReportViewer1.ServerReport.ReportPath = Helpers.GetConfigEntry("BaseReportPath") + ReportViewer1.ServerReport.ReportPath;
                    //ReportViewer1.ServerReport.ReportPath = config.BaseReportPath + ReportViewer1.ServerReport.ReportPath;
                }
                _reportViewerHandler.AddReportVariable("VeteranSSN", _ssn);
                _reportViewerHandler.AddReportVariable("Username", _currentUser1.FullName);
                _reportViewerHandler.AddReportVariable("FacilityId", _facilityId);
                _reportViewerHandler.SetServerReportParameters(ReportViewer1);

                ReportViewer1.Visible = true;
                ReportViewer1.ProcessingMode = ProcessingMode.Remote;
                ReportViewer1.Visible = true;
                ReportViewer1.ServerReport.Refresh();
            }
            catch (Exception _ex)
            {
                //_tbiexception.HandleTBIException(_ex, "PatientHealthFactors.aspx", "100008", "VeteransScreeningQuestions() ReportData");
            } 
        }
        else
        {
            _reportViewerHandler = (ReportViewerHandler)ViewState["ReportViewerHandler"];
        }

        
   }
    protected void ObjectDataSourcePatientHealthFactors_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        try
        {
            e.InputParameters["referralId"] = int.Parse(Page.Request.QueryString["id"]);
        }
        catch (Exception _ex)
        {
            //_tbiexception.HandleTBIException(_ex, "PatientHealthFactors.aspx", "100008", "ObjectDataSourcePatientHealthFactors Selecting()");
        } 
    }
    protected void SqlDataSourceSection1_Selecting(object sender, SqlDataSourceSelectingEventArgs e)
    {
        try
        {
            if (!string.IsNullOrEmpty(Page.Request.QueryString["id"]))
            {
                e.Command.Parameters["@referralId"].Value = int.Parse(Page.Request.QueryString["id"]);
            }
        }
        catch (Exception _ex)
        {
            //_tbiexception.HandleTBIException(_ex, "PatientHealthFactors.aspx", "100008", "SqlDataSourceSection1 Selecting()");
        }
    }

    #endregion

}
