﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using VeteransAffairs.Registries.Business;
using VeteransAffairs.Registries.BusinessManager;
using VeteransAffairs.Registries.BusinessManager.Utilities;
using VeteransAffairs.Registries.BusinessManager.TBI;


public partial class SEU : System.Web.UI.Page
{

    #region Variable Declarations

    //TBIExceptionHandler _tbiexception = new TBIExceptionHandler();

    #endregion

    #region Protected Methods

    protected void Page_Load(object sender, EventArgs e)
    {
        UserAccountManager currentUser = (UserAccountManager)HttpContext.Current.User;
        if (currentUser.HasAccessToRegistry() == false
            || currentUser.IsSuperUser == false)
        {
            Response.Redirect("ErrorPage.aspx?id=100");
        }
      
    }

    protected void ButtonExecute_Click(object sender, EventArgs e)
    {

        if (!string.IsNullOrEmpty(TextBoxSQL.Text))
        {
            if (TextBoxSQL.Text.ToLower().Contains("insert")
                || TextBoxSQL.Text.ToLower().Contains("update")
                || TextBoxSQL.Text.ToLower().Contains("delete"))
            {
                string timeBegin = DateTime.Now.ToString();

                SqlDataSource1.UpdateCommand = TextBoxSQL.Text;
                try
                {
                    SqlDataSource1.Update();
                    bool sucessful = AddRecordToDatabaseChangeLog();
                    string timeEnd = DateTime.Now.ToString();
                    if (sucessful)
                    {
                        Alert.Show("Execute is successful.");
                        LabelExecutionTime.Text = "Transaction Start: " + timeBegin + ", Transaction End: " + timeEnd;
                    }
                    else
                    {
                        Alert.Show("SQL Statement Execute is successful.  Failed to insert to DatabaseChangeLog");
                    }
                }
                catch (Exception ex)
                {
                     //_tbiexception.HandleTBIException(ex, "SEU.aspx", "100033", "Failed to insert to DatabaseChangeLog");
                    Alert.Show(ex.Message);
                }
            }
            else
            {
                Alert.Show("Invalid SQL Statement.  Only insert, update or delete is allowed.");
            }
        }
        else
        {
            Alert.Show("Please enter a SQL Statement.");
            TextBoxSQL.Focus();
        }
    }

    protected void ButtonClear_Click(object sender, EventArgs e)
    {
        LabelExecutionTime.Text = string.Empty;

        TextBoxSQL.Text = string.Empty;
        TextBoxSQL.Focus();
    }

    protected void SqlDataSource1_Updating(object sender, SqlDataSourceCommandEventArgs e)
    {
        e.Command.CommandTimeout = 50000;
    }


    #endregion

    #region Private Methods

    private bool AddRecordToDatabaseChangeLog()
    {
        bool result = false;
        SqlDataSource1.UpdateCommand = "INSERT INTO DatabaseChangeLog (MajorReleaseNumber, " 
            + "MinorReleaseNumber, PointReleaseNumber, Hotfix, ScriptName, ScriptDescription, " 
            + "TargetRegistry, DateApplied) VALUES ('88', '00', '0000', 1, '" 
            + HttpContext.Current.User.Identity.Name + "', '" + TextBoxSQL.Text.Replace("'", "''") + "',  " 
            + "'ALL', getdate())";
        try
        {
            SqlDataSource1.Update();
            result = true;
        }
        catch (Exception ex)
        {
            //_tbiexception.HandleTBIException(ex, "SEU.aspx", "100033", "AddRecordToDatabaseChangeLog()");
            result = false;
        }

        return result;
    }

    #endregion

}
