﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using System.Web;
using System.Xml;
using System.Web.UI;
using System.Web.UI.WebControls;
using VeteransAffairs.Registries.BusinessManager;

public partial class TBI_Instruments_Warning : System.Web.UI.Page
{
    private UserAccountManager _currentUser;

    protected void Page_Load(object sender, EventArgs e)
    {
        Master.FindControl("UserInformation").Visible = false;

        string errCode = String.Empty;
        string _returnErrorXML = String.Empty;
        string messageVal = String.Empty;
        string suggestionVal = String.Empty;

        errCode = Request.QueryString["err"];
        //errCode = "1";

        switch (errCode)
        {
            case "1":
                //RETRIEVE DATA
                if (_currentUser == null)
                {
                    Reports r = new Reports("vaaitcheathm");//hardcode my user for debugging
                    DataTable dtConnectionErrors = r.GetTBIConnectionError().Copy();
                    dtConnectionErrors.TableName = "MDWS_LOG";

                    foreach (DataRow _error in dtConnectionErrors.Rows)
                    {
                        _returnErrorXML = _error["ERROR_XML"].ToString();
                    }
                }
                else
                {
                    if (_currentUser.UserId.ToString().Length > 0)
                    {
                        Reports r = new Reports(_currentUser.UserId.ToString());
                        DataTable dtConnectionErrors = r.GetTBIConnectionError().Copy();
                        dtConnectionErrors.TableName = "MDWS_LOG";

                        foreach (DataRow _error in dtConnectionErrors.Rows)
                        {
                            _returnErrorXML = _error["ERROR_XML"].ToString();
                        }
                    }
                }

                if (_returnErrorXML.Length > 0)
                {
                    //CREATE NEW XML DOC WITH RECORD XML
                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.LoadXml(_returnErrorXML);

                    //PARSE OUT ERROR MESSASE FIELD DATA
                    XmlNodeList elementList = xmlDoc.GetElementsByTagName("messageField");
                    if (elementList != null)
                    {
                        for (int i = 0; i < elementList.Count; i++)
                        {
                            messageVal = elementList[i].InnerText;
                        }
                    }

                    //PARSE OUT ERROR SUGGESTION FIELD DATA
                    XmlNodeList elementList2 = xmlDoc.GetElementsByTagName("suggestionField");
                    if (elementList2 != null)
                    {
                        for (int i = 0; i < elementList2.Count; i++)
                        {
                            suggestionVal = elementList2[i].InnerText;
                        }
                    }

                    //DISPLAY RETURNED XML ERROR TEXT TO USER
                    LabelMessage.Text = "MDWS could not make a connection to the CPRS system requested." + "<br />";
                    if (messageVal.Length > 0)
                    {
                        lblDataMessage.Text += "<b>VISTA site error message:</b> <font color='red'>" + messageVal + "</font><br />";
                    }else{
                        lblDataMessage.Text += "<b>VISTA site error message:</b> <font color='red'>N/A</font><br />";
                    }

                    if (suggestionVal.Length > 0)
                    {
                        lblSuggestionText.Text += "<b>VISTA site error suggestion:</b> <font color='red'>" + suggestionVal + "</font><br />";
                    }
                    else
                    {
                        lblSuggestionText.Text += "<b>VISTA site error suggestion:</b> <font color='red'>N/A</font><br />";
                    }
                }
                else
                {
                    LabelMessage.Text = "MDWS could not make a connection to the CPRS system requested.";
                }
                break;
            case "9":
                LabelMessage.Text = "Data for this patient was modified in a concurrent session.";
                break;
            case "11":
                LabelMessage.Text = "An internal error has occurred that requires termination of this program.  Please close all browsers that you have open in this application.";
                break;
            case "12345":
                LabelMessage.Text = "VIA could not make a connection to the CPRS system requested.";
                break;
        }
    }
}
